﻿// for Adobe Illustrator
// exports artboards as monotone (aliased) PSDs

// the final artboard is skipped (reserved for a 'canvas')
// hide artwork on artboards first to prevent them being exported

/*------------------------------------------------------------------------*/
function exportFileToPSDs (dest) { 
/*------------------------------------------------------------------------*/
	var exportOptions = new ExportOptionsPhotoshop();
	var type = ExportType.PHOTOSHOP;
	var fileSpec = new File(dest);
	exportOptions.saveMultipleArtboards = true;
	exportOptions.artboardRange = "1-" + (num_artboards-1);
	exportOptions.antiAliasing = false;
	exportOptions.editableText = false;
	exportOptions.maximumEditability = false;
	exportOptions.resolution = 72;
	exportOptions.warnings = false;
	exportOptions.writeLayers = false;
	app.activeDocument.exportFile( fileSpec, type, exportOptions );
}

//--------------------------------------------------------//

// initialise
app.userInteractionLevel = UserInteractionLevel.DONTDISPLAYALERTS;
var doc = app.activeDocument;
var docName = doc.name;
var docName = docName.substr(0, docName.lastIndexOf('.'));
var ab = doc.artboards;
var num_artboards =  doc.artboards.length;

// user prompt
var filePath = new Folder(arguments[0]) // 'arguments[0]' saves to 'destinationFolder' variable in Applescript
var saveFolder = new Folder(filePath);

// export all the artboards
exportFileToPSDs (saveFolder);

// remove beginning of filenames and leave only artboard names
exportFolder = saveFolder.getFiles();
numFiles = exportFolder.length;
for (i=0;i<numFiles;i++)
{
    var cur_name = exportFolder[i].name;
    var new_name = cur_name.replace(docName+'_', '');
    var file_path = saveFolder.toString() + "/" + cur_name;
    var theFile = new File(file_path);
    theFile.rename(new_name);
}