﻿/*---------------------------------------------------*/
function clean_hex(input) 
/*---------------------------------------------------*/
{
	input = input.toUpperCase();
	input = input.replace(/0x/gi, "");
	input = input.replace(/[^A-Fa-f0-9]/g, "");
	return input;    
}

/*---------------------------------------------------*/
function hex_to_binary (input)
/*---------------------------------------------------*/
{
	var binary = new Array();
	for (var i=0; i<input.length/2; i++) {
		var h = input.substr(i*2, 2);
		binary[i] = 255 - parseInt(h,16); // '255 -' inverts the image
	}
	return binary;
}

/*---------------------------------------------------*/
function binary_to_base64 (input) 
/*---------------------------------------------------*/
{
	var base64_chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	var ret = new Array();
	var i = 0;
	var j = 0;
	var char_array_3 = new Array(3);
	var char_array_4 = new Array(4);
	var in_len = input.length;
	var pos = 0;

	while (in_len--)
	{
	  char_array_3[i++] = input[pos++];
	  if (i == 3)
	  {
		  char_array_4[0] = (char_array_3[0] & 0xfc) >> 2;
		  char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
		  char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
		  char_array_4[3] = char_array_3[2] & 0x3f;

		  for (i = 0; (i <4) ; i++)
			  ret += base64_chars.charAt(char_array_4[i]);
		  i = 0;
	  }
	}

	if (i)
	{
	  for (j = i; j < 3; j++)
		  char_array_3[j] = 0;

	  char_array_4[0] = (char_array_3[0] & 0xfc) >> 2;
	  char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
	  char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
	  char_array_4[3] = char_array_3[2] & 0x3f;

	  for (j = 0; (j < i + 1); j++)
		  ret += base64_chars.charAt(char_array_4[j]);

	  while ((i++ < 3))
		  ret += '=';

	}

	return ret;
}

/*---------------------------------------------------*/
function grabLines (start_str, end_str, haystack) 
/*---------------------------------------------------*/
{
	var found = false;
	var line = "";
	var lines = "";
	while (!haystack.eof)
	{
		line = haystack.readln();
		if (found) {
			if (line.indexOf(end_str) > -1) return lines;
			lines += line;
		}
		if (line.indexOf(start_str) > -1) {
			found = true;
		}
	}
}

/*---------------------------------------------------*/

var ind = "   ";
var dataString =         Array(3).join(ind) + '{';
	dataString += '\n' + Array(4).join(ind) + '"id":0,';
	dataString += '\n' + Array(4).join(ind) + '"items":[';
var destinationFolder = new Folder(arguments[0]);

var files = destinationFolder.getFiles("*.xbm");
files.sort();

for (var i=0; i<files.length; i++) {
	
	var inputFile = new File(files[i]);
	var filename = decodeURI(inputFile.name.slice(0, -4));
	inputFile.open("r","","");
	var hexArray = grabLines ('{', '}', inputFile);
	var cleanHex = clean_hex (hexArray);
	var bin = hex_to_binary (cleanHex);
	var base64 = binary_to_base64 (bin);
	
	if (i>0) dataString += ',';
	dataString += '\n' + Array(5).join(ind) + '{';
	dataString += '\n' + Array(6).join(ind) + '"value":'+i+',';
	dataString += '\n' + Array(6).join(ind) + '"label":"'+filename+'",';
	dataString += '\n' + Array(6).join(ind) + '"bitmap":"'+base64+'"';
	dataString += '\n' + Array(5).join(ind) + '}';
}

dataString += '\n' + Array(4).join(ind) + ']';
dataString += '\n' + Array(3).join(ind) + '}';

// delete image files
//~ files = destinationFolder.getFiles("*.psd");
//~ for (var i=0; i<files.length; i++) {
//~ 	var file = new File(files[i]);
//~ 	file.remove();
//~ }

//~ files = destinationFolder.getFiles("*.xbm");
//~ for (var i=0; i<files.length; i++) {
//~ 	var file = new File(files[i]);
//~ 	file.remove();
//~ }

// write JSON file
var outputFile = new File(destinationFolder + "/output.json");
outputFile.encoding = "UTF-8";
outputFile.open("w");
outputFile.write(dataString);
outputFile.close();